"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pipe_1 = require("@reactive-js/pipe");
const observable_1 = require("@reactive-js/observable");
const createAsyncEnumerable_1 = require("./createAsyncEnumerable");
exports.createActionReducer = (reducer, initialState, equals) => {
    const operator = (src) => {
        const acc = initialState();
        return pipe_1.pipe(src, observable_1.scan(reducer, () => acc), observable_1.startWith(acc), observable_1.distinctUntilChanged(equals));
    };
    return createAsyncEnumerable_1.createAsyncEnumerable(operator);
};
const stateStoreReducer = (state, action) => action(state);
exports.createStateStore = (initialState, equals) => exports.createActionReducer(stateStoreReducer, initialState, equals);
//# sourceMappingURL=actionReducer.js.map