"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const observable_1 = require("@reactive-js/observable");
const createAsyncEnumerable_1 = require("./createAsyncEnumerable");
const pipe_1 = require("@reactive-js/pipe");
class LiftedAsyncEnumerable extends createAsyncEnumerable_1.AsyncEnumerableImpl {
    constructor(op, src, obsOps, reqOps) {
        super(op);
        this.src = src;
        this.obsOps = obsOps;
        this.reqOps = reqOps;
    }
}
const reducer = (acc, next) => next(acc);
const createFactory = (obsOps, reqOps, requests) => (enumerator) => {
    const observable = obsOps.reduce(reducer, enumerator);
    const mapRequest = (req) => reqOps.reduce(reducer, req);
    const onRequest = pipe_1.pipe(requests, observable_1.map(mapRequest), observable_1.onNotify((req) => enumerator.dispatch(req)), observable_1.ignoreElements());
    return observable_1.merge(observable, onRequest);
};
const liftImpl = (enumerable, obsOps, reqOps) => {
    const src = enumerable instanceof LiftedAsyncEnumerable ? enumerable.src : enumerable;
    const op = (requests) => observable_1.using(scheduler => src.enumerateAsync(scheduler), createFactory(obsOps, reqOps, requests));
    return new LiftedAsyncEnumerable(op, src, obsOps, reqOps);
};
exports.lift = (op) => enumerable => {
    const obsOps = enumerable instanceof LiftedAsyncEnumerable
        ? [...enumerable.obsOps, op]
        : [op];
    const reqOps = enumerable instanceof LiftedAsyncEnumerable ? enumerable.reqOps : [];
    return liftImpl(enumerable, obsOps, reqOps);
};
exports.liftReq = (op) => enumerable => {
    const obsOps = enumerable instanceof LiftedAsyncEnumerable ? enumerable.obsOps : [];
    const reqOps = enumerable instanceof LiftedAsyncEnumerable
        ? [op, ...enumerable.reqOps]
        : [op];
    return liftImpl(enumerable, obsOps, reqOps);
};
//# sourceMappingURL=lift.js.map