"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const observable_1 = require("@reactive-js/observable");
const option_1 = require("@reactive-js/option");
const pipe_1 = require("@reactive-js/pipe");
const createAsyncEnumerable_1 = require("./createAsyncEnumerable");
const map_1 = require("./map");
const createStream = (f) => createAsyncEnumerable_1.createAsyncEnumerable(obs => observable_1.concat(f(obs), observable_1.never()));
const emptyModeMapper = (mode) => mode === 1 ? { type: 2 } : option_1.none;
const onEmptyOperator = pipe_1.compose(observable_1.map(emptyModeMapper), observable_1.keepType(option_1.isSome), observable_1.takeFirst());
exports.emptyStream = () => createStream(onEmptyOperator);
const ofValueModeMapper = (data) => (mode) => mode === 1
    ? observable_1.fromArray([
        { type: 1, data },
        { type: 2 },
    ])
    : option_1.none;
const ofValueOperator = (value) => pipe_1.compose(observable_1.map(ofValueModeMapper(value)), observable_1.keepType(option_1.isSome), observable_1.takeFirst(), observable_1.switchAll());
exports.ofValueStream = (value) => createStream(ofValueOperator(value));
const generateScanner = (generator, delay) => (acc, ev) => ev === 1
    ? observable_1.generate(generator, () => acc, delay)
    : observable_1.empty();
exports.generateStream = (generator, initialValue, delay = 0) => createStream(pipe_1.compose(observable_1.scanAsync(generateScanner(generator, delay), initialValue, 1), observable_1.map(data => ({ type: 1, data }))));
exports.mapStream = (mapper) => map_1.map((ev) => ev.type === 1
    ? {
        type: 1,
        data: mapper(ev.data),
    }
    : { type: 2 });
//# sourceMappingURL=stream.js.map