import { pipe } from "@reactive-js/pipe";
import { distinctUntilChanged, scan, startWith, } from "@reactive-js/observable";
import { createAsyncEnumerable } from "./createAsyncEnumerable";
export const createActionReducer = (reducer, initialState, equals) => {
    const operator = (src) => {
        const acc = initialState();
        return pipe(src, scan(reducer, () => acc), startWith(acc), distinctUntilChanged(equals));
    };
    return createAsyncEnumerable(operator);
};
const stateStoreReducer = (state, action) => action(state);
export const createStateStore = (initialState, equals) => createActionReducer(stateStoreReducer, initialState, equals);
//# sourceMappingURL=actionReducer.js.map