import { compute, map, merge, onNotify, switchAll, takeLast, using, onSubscribe, onDispose, empty, withLatestFrom, } from "@reactive-js/observable";
import { compose, pipe } from "@reactive-js/pipe";
import { identity } from "./identity";
import { lift } from "./lift";
const createAcc = (enumerator) => {
    const onNotifyDispatch = (continueRequest) => {
        enumerator.dispatch(continueRequest.req);
    };
    return pipe(identity(), lift(onNotify(onNotifyDispatch)));
};
const createResources = (enumerator) => (scheduler) => [
    createAcc(enumerator).enumerateAsync(scheduler),
    identity().enumerateAsync(scheduler),
];
const createFactory = (withLatestFrom, initial, enumerator) => (request, src) => {
    const mapReducerRequestToAcc = map(({ acc }) => acc);
    const doOnDispose = (_) => {
        src.dispose();
    };
    const setupOnSubscribe = () => {
        const next = pipe(enumerator, onDispose(doOnDispose));
        src.dispatch(next);
    };
    const notifySrc = (next) => {
        if (next.type === 1) {
            request.dispatch(next);
        }
        else {
            src.dispatch(empty());
        }
    };
    return pipe(merge(compute(initial), pipe(src, switchAll(), withLatestFrom(mapReducerRequestToAcc(request)))), onNotify(notifySrc), mapReducerRequestToAcc, takeLast(), onSubscribe(setupOnSubscribe));
};
const consumeImpl = (withLatestFrom, initial) => enumerator => using(createResources(enumerator), createFactory(withLatestFrom, initial, enumerator));
export const consume = (reducer, initial) => {
    const withLatestSelector = (next, acc) => reducer(acc, next);
    return consumeImpl(acc => withLatestFrom(acc, withLatestSelector), initial);
};
export const consumeAsync = (reducer, initial) => {
    const withLatestSelector = (next, acc) => reducer(acc, next);
    return consumeImpl(acc => compose(withLatestFrom(acc, withLatestSelector), switchAll()), initial);
};
//# sourceMappingURL=consume.js.map