import { MulticastObservableLike, SafeSubscriberLike } from "@reactive-js/observable";
import { SchedulerLike } from "@reactive-js/scheduler";
import { Operator } from "@reactive-js/pipe";
export interface AsyncEnumeratorLike<TReq, T> extends SafeSubscriberLike<TReq>, MulticastObservableLike<T> {
}
export interface AsyncEnumerableLike<TReq, T> {
    enumerateAsync(scheduler: SchedulerLike, replayCount?: number): AsyncEnumeratorLike<TReq, T>;
}
export declare type AsyncEnumerableOperator<TSrcReq, TSrc, TReq, T> = {
    (enumerable: AsyncEnumerableLike<TSrcReq, TSrc>): AsyncEnumerableLike<TReq, T>;
};
export declare type StateUpdater<T> = {
    (oldState: T): T;
};
export declare const enum StreamMode {
    Produce = 1,
    Pause = 2
}
export declare const enum StreamEventType {
    Next = 1,
    Complete = 2
}
export declare type StreamEvent<T> = {
    readonly type: StreamEventType.Next;
    readonly data: T;
} | {
    readonly type: StreamEventType.Complete;
};
export interface StreamLike<T> extends AsyncEnumerableLike<StreamMode, StreamEvent<T>> {
}
export interface StreamSinkLike<T> extends AsyncEnumerableLike<StreamEvent<T>, StreamMode> {
}
export declare type StreamOperator<TA, TB> = Operator<StreamLike<TA>, StreamLike<TB>>;
