import { generate as generateObs, map as mapObs, keepType, takeFirst, never, concat, fromArray, scanAsync, switchAll, empty, } from "@reactive-js/observable";
import { none, isSome } from "@reactive-js/option";
import { compose } from "@reactive-js/pipe";
import { createAsyncEnumerable } from "./createAsyncEnumerable";
import { map } from "./map";
const createStream = (f) => createAsyncEnumerable(obs => concat(f(obs), never()));
const emptyModeMapper = (mode) => mode === 1 ? { type: 2 } : none;
const onEmptyOperator = compose(mapObs(emptyModeMapper), keepType(isSome), takeFirst());
export const emptyStream = () => createStream(onEmptyOperator);
const ofValueModeMapper = (data) => (mode) => mode === 1
    ? fromArray([
        { type: 1, data },
        { type: 2 },
    ])
    : none;
const ofValueOperator = (value) => compose(mapObs(ofValueModeMapper(value)), keepType(isSome), takeFirst(), switchAll());
export const ofValueStream = (value) => createStream(ofValueOperator(value));
const generateScanner = (generator, delay) => (acc, ev) => ev === 1
    ? generateObs(generator, () => acc, delay)
    : empty();
export const generateStream = (generator, initialValue, delay = 0) => createStream(compose(scanAsync(generateScanner(generator, delay), initialValue, 1), mapObs(data => ({ type: 1, data }))));
export const mapStream = (mapper) => map((ev) => ev.type === 1
    ? {
        type: 1,
        data: mapper(ev.data),
    }
    : { type: 2 });
//# sourceMappingURL=stream.js.map