import { ObservableLike } from "@reactive-js/observable";
import { Operator } from "@reactive-js/pipe";
import { AsyncEnumeratorLike } from "./interfaces";
export declare const enum ReducerRequestType {
    Continue = 1,
    Done = 2
}
export declare type ContinueRequest<TReq, TAcc> = {
    readonly type: ReducerRequestType.Continue;
    readonly req: TReq;
    readonly acc: TAcc;
};
export declare type DoneRequest<TAcc> = {
    readonly type: ReducerRequestType.Done;
    readonly acc: TAcc;
};
export declare type ReducerRequest<TReq, TAcc> = ContinueRequest<TReq, TAcc> | DoneRequest<TAcc>;
export declare const consume: <TReq, T, TAcc>(reducer: (acc: TAcc, next: T) => ReducerRequest<TReq, TAcc>, initial: () => ReducerRequest<TReq, TAcc>) => Operator<AsyncEnumeratorLike<TReq, T>, ObservableLike<TAcc>>;
export declare const consumeAsync: <TReq, T, TAcc>(reducer: (acc: TAcc, next: T) => ObservableLike<ReducerRequest<TReq, TAcc>>, initial: () => ReducerRequest<TReq, TAcc>) => Operator<AsyncEnumeratorLike<TReq, T>, ObservableLike<TAcc>>;
//# sourceMappingURL=consume.d.ts.map